<?php
/*
Plugin Name: Month Totals
Plugin URI: http://dualrudder.com/
Description: This plugin adds up the "Hours" meta data by month and displays it.  Updated for WP 2.0+ table structure
Author: Dave Parsons, updated by Joshua Wyatt
Version: 2.1
Author URI: http://dualrudder.com/
*/ 

$hoursfield = 'Hours';

function display_month_totals() {

    global $wpdb;
	global $hoursfield;
    
    echo "<strong>Total hours by month:</strong><br /><br />\n";
    
    // Get hours summed by month, sorted by month
    $hours = $wpdb->get_results("SELECT
        DATE_FORMAT(post_date, '%M %Y'), FORMAT(SUM(pm.meta_value), 1)
        FROM $wpdb->posts
        INNER JOIN $wpdb->postmeta AS pm ON (pm.post_ID = ID)
        WHERE pm.meta_key = '$hoursfield'
        AND post_status = 'publish'
        AND post_date_gmt <= utc_timestamp()
        GROUP BY date_format(post_date, '%M %Y')
        ORDER BY date_format(post_date, '%Y %m')", ARRAY_N);

    echo "<table frame=box>\n";
    echo "<tr><th align=center>Month</th><th align=center>Hours</th><th></th></tr>\n";

    foreach ($hours as $row) { 
	$barwidth = round($row[1] * 4);
        echo "<tr><td>$row[0]</td><td align=right>$row[1]</td><td><img src='" . plugin_dir_url('month-totals-20') . "month-totals-20/bar.gif' height=10 width=$barwidth></td></tr>\n";
    }
    
    echo "</table>\n";

    $monthsworked = $wpdb->get_var("SELECT
        count(distinct date_format(post_date, '%Y %M'))
        FROM $wpdb->posts
        INNER JOIN $wpdb->postmeta AS pm ON (pm.post_ID = ID)
        WHERE pm.meta_key = '$hoursfield'
        AND post_status = 'publish'
        AND post_date_gmt <= utc_timestamp()");

    $hoursworked = $wpdb->get_var("SELECT
        sum(meta_value)
	FROM $wpdb->postmeta
	WHERE meta_key = '$hoursfield'");

    echo "<br /><strong>Total number of hours worked:</strong> ".$hoursworked."<br />\n";
    echo "<strong>Total number of months logged:</strong> ".$monthsworked."<br />\n";
    echo "<strong>Average hours per month:</strong> ".round($hoursworked/$monthsworked, 2)."<br />\n";

}

function display_total_days() {
    
    global $wpdb;
	global $hoursfield;

    $daysworked = $wpdb->get_var("SELECT
        count(distinct date_format(post_date, '%Y %M %D'))
        FROM $wpdb->posts
        INNER JOIN $wpdb->postmeta AS pm ON (pm.post_ID = ID)
        WHERE pm.meta_key = '$hoursfield'
        AND post_status = 'publish'
        AND post_date_gmt <= utc_timestamp()");

    $hoursworked = $wpdb->get_var("SELECT
        sum(meta_value)
	FROM $wpdb->postmeta
	WHERE meta_key = '$hoursfield'");

    echo "<br /><strong>Total number of days logged:</strong> ".$daysworked."<br />\n";
    echo "<strong>Average hours per day:</strong> ".round($hoursworked/$daysworked, 2)."<br />\n";

}

?>